//
//  バブルソート
//
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define N 30

void bubblesort(int *, int);


int main(int argc, char **argv)
{
    int x[N];  //  ソートすべきデータ
    int i;     //  ループ用


    srandom(time(NULL));

    for (i = 0 ; i < N ; i++)
    {
        x[i] = random() % 1000;
    }

    printf("--- 整列前 ---\n");
    for (i = 0 ; i < N ; i++)
    {
        printf("%4d", x[i]);
    }
    printf("\n");

    bubblesort(x, N);

    printf("--- 整列後 ---\n");
    for (i = 0 ; i < N ; i++)
    {
        printf("%4d", x[i]);
    }
    printf("\n");

    return(0);
}


//
//  2つの整数変数を入れ替える
//
void swap(int *a, int *b)
{
    int t;


    t = *a;
    *a = *b;
    *b = t;
}



//
//  バブルソートによるソートルーチン
//  x[] : データ本体
//  n : データの個数
//
void bubblesort(int *x, int n)
{
    int i, j;


    for (j = 0 ; j < n - 1 ; j++)
    {
        for (i = 0 ; i < n - 1 - j ; i++)
        {
            if (*(x + i) > *(x + i + 1)) swap(x + i, x + i + 1);
        }
    }
}
