//
//  直接選択ソート
//
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define N 30

void selectionsort(int *, int);


int main(int argc, char **argv)
{
    int x[N];  //  ソートすべきデータ
    int i;     //  ループ用


    srandom(time(NULL));

    for (i = 0 ; i < N ; i++)
    {
        x[i]=random() % 1000;
    }

    printf("--- 整列前 ---\n");
    for (i = 0 ; i < N ; i++)
    {
        printf("%4d", x[i]);
    }
    printf("\n");

    selectionsort(x, N);

    printf("--- 整列後 ---\n");
    for (i = 0 ; i < N ; i++)
    {
        printf("%4d", x[i]);
    }
    printf("\n");

    return(0);
}


//
//  2つの整数変数を入れ替える
//
void swap(int *a, int *b)
{
    int t;


    t = *a;
    *a = *b;
    *b = t;
}


//
//  選択ソートによるソートルーチン
//  x[]  : データ本体
//  n : データの個数
//
void selectionsort(int *x, int n)
{
    int i, j;
    int min;
    int idx;


    for (i = 0 ; i < n - 1 ; i++)
    {
        min = *(x + i);
        idx = i;
        for (j = i + 1 ; j < n ; j++)
        {
            if (*(x + j) < min)
            {
                min = *(x + j);
                idx = j;
            }
        }
        swap(x + i, x + idx);
    }
}
